<!DOCTYPE html>
<head>
	<title>Not In List</title>
	<link href="not_in_list_stylesheet.css"  rel="stylesheet" type="text/css" media="only screen">
	<html lang="en">
	<meta name="description" content="Not In List">
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	<meta charset="utf-8">
</head>

<html>
	<body onload="on_load()">
		<!--**********************************************************************************************************
			Select Author Name From drop-down list section.
			Press Ctrl+F5 for hard refresh on your browser page it removes Cache of current page and load the newly Edited Page
			Press F12 to show console
			************************************************************************************************************ -->
		<br>
		<h2>Author Not in List Project</h2>
		<br>

		<?php
			require_once 'php_functions/functions.php';
			require_once 'php_data/login_data.php';
			// ***********************************************************************************
			// Get the list of authors stored on the server
			// ***********************************************************************************
			login();
			$query = "Select AuthorIDNUM, AuthorLast,AuthorFirst
							FROM tblAuthorListX
							ORDER BY AuthorLast, AuthorFirst";

			$result =$conn->query($query);	
			if (!$result) die($conn->error);
			$rows = mysqli_num_rows($result);
		?>
		<!--************************************************************************************************************************* -->
		<!--                                                            Start of Author Form                                                                                                                                       -->
		<!--************************************************************************************************************************* -->
		<div>
			<form enctype='multipart/form-data' action='index.php' method='post' id='author_form'>
				<td><input list='author_list' id='answer' name='authorname' placeholder='Select Author'   oninput='show_letter()'   autofocus required >
					<datalist id='author_list' style='background-color: aqua; height: 3em;'>
							<?php
								while($row=mysqli_fetch_array($result,MYSQLI_ASSOC))
									{
										$authoridnum = $row['AuthorIDNUM'];
										$authorlast = $row['AuthorLast'];
										$authorfirst = $row['AuthorFirst'];
										echo "<option data-value='$authoridnum'>$authorfirst" . ", " . "$authorlast</option>";
										$AuthorPHPArray[] = $row['AuthorIDNUM'] . ", " . strtoupper($row['AuthorFirst']) .  ", " . strtoupper($row['AuthorLast']);
									}
							?>
					</datalist>
						<!-- Execute Form actions on server. Execute Form actions on server with author_exec_form.inc.php -->
						<input type="submit" value="Submit" onclick="unset_new_author()" >
						<input type='hidden' name='answer' id='answer-hidden'>
						<input type='hidden' name='content' value='result_form'>
			</form>
		<!-- *********************************************************************************** -->
		<!--                                                        End of Author Form                                                                     -->
		<!-- *********************************************************************************** -->
		</div>	<br><br>
			<a href="index.php?content=author_form"  id="author_form_refresh" title ="Refresh author_form" onclick="unset_new_author()" >Refresh Author Form</a>
				<br><br>
				<p style="margin-left: 33em;">author_form_inc.php</p>
				<p style="margin-left: 34em;">First Form Called</p>
	</body>
</html>


<!-- ============================================================================================================= -->
<!-- Javascript  Section Below     Javascript  Section Below        Javascript  Section Below       Javascript  Section Below      Javascript  Section Below       -->
<!-- ============================================================================================================= -->

<!-- ============================================================================================================= 
	Modal Form examples: ww.w3schools.com/w3css/w3css_modal.asp     
	 https://www.aspsnippets.com/Articles/JavaScript-windowopen-Display-Modal-Popup-Window.aspx 
	 https://www.aspsnippets.com/Articles/Open-PopUps-and-exchange-data-between-parent-page-and-PopUp-using-JavaScript.aspx 
	 https://www.geeksforgeeks.org/how-to-pass-a-php-array-to-a-javascript-function/
	 
	 https://developer.mozilla.org/en-US/docs/Web/API/HTMLDataListElement
	 http://stackoverflow.com/questions/29882361/show-datalist-labels-but-submit-the-actual-value 
	 http://jsfiddle.net/7k3sovht/7/
	 http://www.w3schools.com/jsref/dom_obj_datalist.asp
	 https://www.xul.fr/javascript/form-send-receive.php
	 https://www.ostraining.com/blog/coding/retrieve-html-form-data-with-php/
================================================================================================================= -->

<script  "text/javascript">
	// Script Below necessary to get the author id number.  Has to be done indirectly.
	document.querySelector('input[list]').addEventListener('input', function(e) {
		var input = e.target,
		list = input.getAttribute('list'),
		options = document.querySelectorAll('#' + list + ' option'),
		hiddenInput = document.getElementById(input.getAttribute('id') + '-hidden'),
		label = input.value;
		hiddenInput.value = label;

		for(var i = 0; i < options.length; i++) {
			var option = options[i];

		if(option.innerText === label) {
			hiddenInput.value = option.getAttribute('data-value');
			break;
										}
											}
			});
			
//============================================================
	function unset_new_author()
		{
					var new_author = 0;
					sessionStorage.setItem("new_author", new_author);
		}

//============================================================

	function show_letter()
			{
				// This function shows the letters one at-a-time as they are typed into the text box.
				// When testing be sure to have the console view visible. Press F12 to view the console.
				var search_string = document.getElementById("answer").value;
				sessionStorage.setItem("namex", search_string);
				search_string=search_string.toUpperCase();
				var MyJavaArray = <?php echo '["' . implode('", "', $AuthorPHPArray) . '"]' ?>; 
				// print_array(MyJavaArray);
				// print_array_elements(MyJavaArray)
				var position=MyJavaArray.findIndex(element => element.includes(search_string));
				// console.log(position);
				if (position >= 0) {
							console.log("String " + search_string + " Found");
					} else {
							console.log(search_string + " NOT Found !!!");
							if (window.confirm("You entered " +  search_string + ". No such author. \nPress Cancel to return to the form to correct your entry.  \nPress OK to enter the name of the missing author.")) {
										console.log("Not Found. Go onto enter new author name");
										window.location.assign('index.php?content=add_author_form');
								} 
				}
			}
// End of function show_letter() ----------------------------------------------------------------------------------------

// ----------------------------------------------------------------------------------------------------------------------------------
	function print_array(MyJavaArray)
		{
				for (var i in MyJavaArray) 
			{
   				console.log("row " + i);
   				for (var j in MyJavaArray[i]) 
     				{
      				console.log(" " + MyJavaArray[i][j]);
     				}
				}
		}

// ----------------------------------------------------------------------------------------------------------------------------------
	function print_array_elements(MyJavaArray)
		{
		for(let i = 0; i < MyJavaArray.length; i++){
 					 console.log(MyJavaArray[i]);
						}
		}
		
// ----------------------------------------------------------------------------------------------------------------------------------
	function show_index() 
		{
			var dictionary = {};
			var options = document.getElementById("author_list").getElementsByTagName("option");
			// var string_b = document.getElementById("author_list").options.length;
			// console.log("Number of Rows " + string_b);

			for (var i = 0; i < options.length; ++i) 
				{
					var option = options[i];
					var dataValue = option.getAttribute("data-value");
					var name = option.text;
					console.log (dataValue, name);
					// dictionary[name] = dataValue; // if you want a different data structure
				}
		}

// ------------------------------------------------------------------------------------------------------------------------------------
	function on_load()
		 {
			console.log("Page 1: on_load event triggered");
			// console.log("This function has to be defined before it is called by php.");
    		//var new_authorid =  '<?php echo "$new_authorid" ; ?>';
    		var new_author = sessionStorage.getItem("new_author");
    		console.log("Page 1: get new author value before if statement: " + new_author );
   		if (new_author == 1) 
				{
					var firstname='<?php echo "$firstname" ; ?>';
					var lastname='<?php echo "$lastname" ; ?>';
					document.getElementById("answer").value = firstname + ", " + lastname;
					new_author = 0;
					sessionStorage.setItem("new_author", new_author);
					console.log("Page 1: value of new author after if statement: " + new_author );
				}
		}


</script> 